package jalview.ws2.utils;

import java.util.ArrayList;

import jalview.ws2.WSJob;

public class WSJobList extends ArrayList<WSJob>
{
  private static final long serialVersionUID = -1684855135603987602L;

  public int countSubmitted() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isSubmitted()) {
        count++;
      }
    }
    return count;
  }

  public int countQueuing() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isQueuing()) count++;
    }
    return count;
  }

  public int countRunning() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isRunning()) count++;
    }
    return count;
  }

  public int countDone() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isDone()) count++;
    }
    return count;
  }

  public int countFailed() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isFailed()) count++;
    }
    return count;
  }

  public int countSuccessful() {
    return countDone() - countFailed() - countCancelled();
  }

  public int countCancelled() {
    int count = 0;
    for (WSJob job : this) {
      if (job.getStatus().isCancelled()) count++;
    }
    return count;
  }
}
